VERSION 2.00
Begin Form frmPublisher 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Editing of Publisher table"
   ClientHeight    =   5505
   ClientLeft      =   195
   ClientTop       =   1500
   ClientWidth     =   5715
   Height          =   5910
   Left            =   135
   LinkTopic       =   "Form2"
   MDIChild        =   -1  'True
   ScaleHeight     =   5505
   ScaleWidth      =   5715
   Top             =   1155
   Width           =   5835
   Begin CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   375
      Left            =   4500
      TabIndex        =   2
      Top             =   3120
      Width           =   1095
   End
   Begin CommandButton cmdEdit 
      Caption         =   "Edit"
      Height          =   375
      Left            =   4500
      TabIndex        =   5
      Top             =   2640
      Width           =   1095
   End
   Begin CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   375
      Left            =   4500
      TabIndex        =   4
      Top             =   2160
      Width           =   1095
   End
   Begin CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   4500
      TabIndex        =   3
      Top             =   4920
      Width           =   1095
   End
   Begin ListBox lstResult 
      Height          =   3150
      Left            =   180
      TabIndex        =   0
      Top             =   2160
      Width           =   4215
   End
   Begin Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This is an example of using the db_SetListPlubisher() and db_GetNextPublisher() routines (generated automatically using the MAIN.TPT template) to fill a listbox with all the Publishers from the database.  Press <Add> to add a Publisher using the db_AddThisPublisher() API call and press <Edit> to edit a Publisher using the db_ModThisPublisher() API call.  Study the code in this form (frmPublisher) as well as the update form (frmPublisherUpd)."
      Height          =   1815
      Left            =   180
      TabIndex        =   1
      Top             =   180
      Width           =   5415
   End
End
Option Explicit

Sub cmdAdd_Click ()

  'set action to ADD
  lstResult.Tag = "ADD"
  'show edit form
  frmPublisherUpd.Show 1
  'if editing was done we should redisplay the listbox
  If Me.Tag = "REDISPLAY" Then
     Call listbox_fill
  End If

End Sub

Sub cmdDelete_Click ()
    
   Dim ErrCode As Integer
   Dim PubKey As tpePublisherKey
   ErrCode = MsgBox("Are you sure you want to delete this record?", 36, "Confirm Delete")
   If ErrCode = 6 Then
      'delete selected record
      PubKey.PubID = lstResult.ItemData(lstResult.ListIndex)
      ErrCode = db_DelThisPublisher(PubKey)
      If ErrCode <> DBERR_OK Then
         MsgBox "Cannot delete Record..."
      Else
         'update listbox by removing deleted item
         lstResult.RemoveItem (lstResult.ListIndex)
      End If
   End If
   
End Sub

Sub cmdEdit_Click ()
    
  'set action to EDIT
  lstResult.Tag = "EDIT"
  'show edit form
  frmPublisherUpd.Show 1
  'if editing was done we should redisplay the listbox
  If Me.Tag = "REDISPLAY" Then
     Call listbox_fill
  End If

End Sub

Sub cmdOK_Click ()
   
   lstResult.Clear
   Unload Me

End Sub

Sub Form_Load ()

  'fill the listbox with all Publishers
  Call listbox_fill

End Sub

Sub listbox_fill ()

'Fill the listbox with all the Publishers
'We encapsulate this routine in a Sub since its called from
'three different places:  Form_Load()
'                         cmdAdd_Click()
'                         cmdEdit_Click()
  
  Dim PubRec As tpePublisher
  Dim TotRecs As Long, r As Long, ErrCode As Integer

  'Clear list box
  lstResult.Clear
  'Create transparent list (dynaset) of Publisher
  ErrCode = db_SetListPublisher("ORDER BY Name", TotRecs)
  If ErrCode = DBERR_OK Then
     For r = 0 To TotRecs - 1
         'Loop and retrieve Authors meeting criteria
         ErrCode = db_GetNextPublisher(PubRec)
         If ErrCode = DBERR_OK Then
            'Add Publisher's name to the listbox
            lstResult.AddItem Trim$(PubRec.Name)
            'Add Publisher ID (key) to listbox for retrieval purposes
            lstResult.ItemData(r) = PubRec.Key.PubID
         Else
            MsgBox "Cannot retrieve Publisher"
            Exit For
         End If
     Next r
  End If

End Sub

